#include "..\Compiler.h"
#include <minmax.h>

/* dqk15w.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "..\f2c.h"
#include <math.h>

/* Subroutine */ int dqk15w_(EXTERN_FUNC *f, double __cdecl w(double *, double *, double *, 
	double *, double *, long *), double *p1, double *p2, 
	double *p3, double *p4, long *kp, double *a, 
	double *b, double *result, double *abserr, double *
	resabs, double *resasc)
{
	 long c__1 = 1;
	 long c__4 = 4;
	 double c_b7 = 1.5;

	 /* Initialized data */

     double xgk[8] = { .9914553711208126,.9491079123427585,
	    .8648644233597691,.7415311855993944,.5860872354676911,
	    .4058451513773972,.2077849550078985,0. };
     double wgk[8] = { .02293532201052922,.06309209262997855,
	    .1047900103222502,.1406532597155259,.1690047266392679,
	    .1903505780647854,.2044329400752989,.2094821410847278 };
     double wg[4] = { .1294849661688697,.2797053914892767,
	    .3818300505051889,.4179591836734694 };

    /* System generated locals */
    double d__1, d__2, d__3;

    /* Local variables */
     long j;
     double fc, fv1[7], fv2[7];
     long jtw;
     double absc, resg, resk, fsum, absc1, absc2, fval1, fval2;
     long jtwm1;
     double hlgth, centr, reskh, uflow;
    extern double d1mach_(long *);
     double epmach, dhlgth;

/* ***begin prologue  dqk15w */
/* ***date written   810101   (yymmdd) */
/* ***revision date  830518   (mmddyy) */
/* ***category no.  h2a2a2 */
/* ***keywords  15-point gauss-kronrod rules */
/* ***author  piessens,robert,appl. math. & progr. div. - k.u.leuven */
/*           de doncker,elise,appl. math. & progr. div. - k.u.leuven */
/* ***purpose  to compute i = integral of f*w over (a,b), with error */
/*                           estimate */
/*                       j = integral of abs(f*w) over (a,b) */
/* ***description */

/*           integration rules */
/*           standard fortran subroutine */
/*           double precision version */

/*           parameters */
/*             on entry */
/*              f      - double precision */
/*                       function subprogram defining the integrand */
/*                       function f(x). the actual name for f needs to be */
/*                       declared e x t e r n a l in the driver program. */

/*              w      - double precision */
/*                       function subprogram defining the integrand */
/*                       weight function w(x). the actual name for w */
/*                       needs to be declared e x t e r n a l in the */
/*                       calling program. */

/*              p1, p2, p3, p4 - double precision */
/*                       parameters in the weight function */

/*              kp     - long */
/*                       key for indicating the type of weight function */

/*              a      - double precision */
/*                       lower limit of integration */

/*              b      - double precision */
/*                       upper limit of integration */

/*            on return */
/*              result - double precision */
/*                       approximation to the integral i */
/*                       result is computed by applying the 15-point */
/*                       kronrod rule (resk) obtained by optimal addition */
/*                       of abscissae to the 7-point gauss rule (resg). */

/*              abserr - double precision */
/*                       estimate of the modulus of the absolute error, */
/*                       which should equal or exceed abs(i-result) */

/*              resabs - double precision */
/*                       approximation to the integral of abs(f) */

/*              resasc - double precision */
/*                       approximation to the integral of abs(f-i/(b-a)) */


/* ***references  (none) */
/* ***routines called  d1mach */
/* ***end prologue  dqk15w */



/*           the abscissae and weights are given for the interval (-1,1). */
/*           because of symmetry only the positive abscissae and their */
/*           corresponding weights are given. */

/*           xgk    - abscissae of the 15-point gauss-kronrod rule */
/*                    xgk(2), xgk(4), ... abscissae of the 7-point */
/*                    gauss rule */
/*                    xgk(1), xgk(3), ... abscissae which are optimally */
/*                    added to the 7-point gauss rule */

/*           wgk    - weights of the 15-point gauss-kronrod rule */

/*           wg     - weights of the 7-point gauss rule */





/*           list of major variables */
/*           ----------------------- */

/*           centr  - mid point of the interval */
/*           hlgth  - half-length of the interval */
/*           absc*  - abscissa */
/*           fval*  - function value */
/*           resg   - result of the 7-point gauss formula */
/*           resk   - result of the 15-point kronrod formula */
/*           reskh  - approximation to the mean value of f*w over (a,b), */
/*                    i.e. to i/(b-a) */

/*           machine dependent constants */
/*           --------------------------- */

/*           epmach is the largest relative spacing. */
/*           uflow is the smallest positive magnitude. */

	Compiler *app = GetCompiler();
/* ***first executable statement  dqk15w */
    epmach = d1mach_(&c__4);
    uflow = d1mach_(&c__1);

    centr = (*a + *b) * .5;
    hlgth = (*b - *a) * .5;
    dhlgth = abs(hlgth);

/*           compute the 15-point kronrod approximation to the */
/*           integral, and estimate the error. */

	*(f->argPtr) = centr;
	app->RunProgram1(f->aPtr2, f->tmpVarPtr, f->iStart, f->iEnd);
    fc = app->aPtr1->retVal * (*w)(&centr, p1, p2, p3, p4, kp);
//    fc = (*f)(&centr) * (*w)(&centr, p1, p2, p3, p4, kp);

	 resg = wg[3] * fc;
    resk = wgk[7] * fc;
    *resabs = abs(resk);
    for (j = 1; j <= 3; ++j) {
	jtw = j << 1;
	absc = hlgth * xgk[jtw - 1];
	absc1 = centr - absc;
	absc2 = centr + absc;

	*(f->argPtr) = absc1;
	app->RunProgram1(f->aPtr2, f->tmpVarPtr, f->iStart, f->iEnd);
	fval1 = app->aPtr1->retVal * (*w)(&absc1, p1, p2, p3, p4, kp);
//	fval1 = (*f)(&absc1) * (*w)(&absc1, p1, p2, p3, p4, kp);

	*(f->argPtr) = absc2;
	app->RunProgram1(f->aPtr2, f->tmpVarPtr, f->iStart, f->iEnd);
	fval2 = app->aPtr1->retVal * (*w)(&absc2, p1, p2, p3, p4, kp);
//	fval2 = (*f)(&absc2) * (*w)(&absc2, p1, p2, p3, p4, kp);

	fv1[jtw - 1] = fval1;
	fv2[jtw - 1] = fval2;
	fsum = fval1 + fval2;
	resg += wg[j - 1] * fsum;
	resk += wgk[jtw - 1] * fsum;
	*resabs += wgk[jtw - 1] * (abs(fval1) + abs(fval2));
/* L10: */
    }
    for (j = 1; j <= 4; ++j) {
	jtwm1 = (j << 1) - 1;
	absc = hlgth * xgk[jtwm1 - 1];
	absc1 = centr - absc;
	absc2 = centr + absc;

	*(f->argPtr) = absc1;
	app->RunProgram1(f->aPtr2, f->tmpVarPtr, f->iStart, f->iEnd);
	fval1 = app->aPtr1->retVal * (*w)(&absc1, p1, p2, p3, p4, kp);
//	fval1 = (*f)(&absc1) * (*w)(&absc1, p1, p2, p3, p4, kp);

	*(f->argPtr) = absc2;
	app->RunProgram1(f->aPtr2, f->tmpVarPtr, f->iStart, f->iEnd);
	fval2 = app->aPtr1->retVal * (*w)(&absc2, p1, p2, p3, p4, kp);
//	fval2 = (*f)(&absc2) * (*w)(&absc2, p1, p2, p3, p4, kp);

	fv1[jtwm1 - 1] = fval1;
	fv2[jtwm1 - 1] = fval2;
	fsum = fval1 + fval2;
	resk += wgk[jtwm1 - 1] * fsum;
	*resabs += wgk[jtwm1 - 1] * (abs(fval1) + abs(fval2));
/* L15: */
    }
    reskh = resk * .5;
    *resasc = wgk[7] * (d__1 = fc - reskh, abs(d__1));
    for (j = 1; j <= 7; ++j) {
	*resasc += wgk[j - 1] * ((d__1 = fv1[j - 1] - reskh, abs(d__1)) + (
		d__2 = fv2[j - 1] - reskh, abs(d__2)));
/* L20: */
    }
    *result = resk * hlgth;
    *resabs *= dhlgth;
    *resasc *= dhlgth;
    *abserr = (d__1 = (resk - resg) * hlgth, abs(d__1));
    if (*resasc != 0. && *abserr != 0.) {
/* Computing MIN */
	d__3 = *abserr * 200. / *resasc;
	d__1 = 1., d__2 = pow(d__3, c_b7);
	*abserr = *resasc * min(d__1,d__2);
    }
    if (*resabs > uflow / (epmach * 50.)) {
/* Computing MAX */
	d__1 = epmach * 50. * *resabs;
	*abserr = max(d__1,*abserr);
    }
    return 0;
} /* dqk15w_ */

