#include <minmax.h>
#include <math.h>
#include "..\Compiler.h"
/* root.f -- translated by f2c (version 20100827).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "..\f2c.h"

/* Builtin functions */
double d_sign(double *a, double *b)
{
	if (*b >= 0) return fabs(*a);
	else return -fabs(*a);
}

/* Subroutine */ int root_(double *t, double *ft, double *b, 
	double *c__, double *relerr, double *abserr, long *
	iflag, ROOT_VARS *RootVars)
{

   /* System generated locals */
    double d__1, d__2;


    /* Local variables */
    extern double d1mach_(long *);


/*  ROOT COMPUTES A ROOT OF THE NONLINEAR EQUATION F(X)=0 */
/*  WHERE F(X) IS A CONTINOUS REAL FUNCTION OF A SINGLE REAL */
/*  VARIABLE X.  THE METHOD USED IS A COMBINATION OF BISECTION */
/*  AND THE SECANT RULE. */

/*  NORMAL INPUT CONSISTS OF A CONTINUOS FUNCTION F AND AN */
/*  INTERVAL (B,C) SUCH THAT F(B)*F(C).LE.0.0.  EACH ITERATION */
/*  FINDS NEW VALUES OF B AND C SUCH THAT THE INTERVAL(B,C) IS */
/*  SHRUNK AND F(B)*F(C).LE.0.0.  THE STOPPING CRITERION IS */

/*          DABS(B-C).LE.2.0*(RELERR*DABS(B)+ABSERR) */

/*  WHERE RELERR=RELATIVE ERROR AND ABSERR=ABSOLUTE ERROR ARE */
/*  INPUT QUANTITIES.  SET THE FLAG, IFLAG, POSITIVE TO INITIALIZE */
/*  THE COMPUTATION.  AS B,C AND IFLAG ARE USED FOR BOTH INPUT AND */
/*  OUTPUT, THEY MUST BE VARIABLES IN THE CALLING PROGRAM. */

/*  IF 0 IS A POSSIBLE ROOT, ONE SHOULD NOT CHOOSE ABSERR=0.0. */

/*  THE OUTPUT VALUE OF B IS THE BETTER APPROXIMATION TO A ROOT */
/*  AS B AND C ARE ALWAYS REDEFINED SO THAT DABS(F(B)).LE.DABS(F(C)). */

/*  TO SOLVE THE EQUATION, ROOT MUST EVALUATE F(X) REPEATEDLY. THIS */
/*  IS DONE IN THE CALLING PROGRAM.  WHEN AN EVALUATION OF F IS */
/*  NEEDED AT T, ROOT RETURNS WITH IFLAG NEGATIVE.  EVALUATE FT=F(T) */
/*  AND CALL ROOT AGAIN.  DO NOT ALTER IFLAG. */

/*  WHEN THE COMPUTATION IS COMPLETE, ROOT RETURNS TO THE CALLING */
/*  PROGRAM WITH IFLAG POSITIVE= */

/*     IFLAG=1  IF F(B)*F(C).LT.0 AND THE STOPPING CRITERION IS MET. */

/*          =2  IF A VALUE B IS FOUND SUCH THAT THE COMPUTED VALUE */
/*              F(B) IS EXACTLY ZERO.  THE INTERVAL (B,C) MAY NOT */
/*              SATISFY THE STOPPING CRITERION. */

/*          =3  IF DABS(F(B)) EXCEEDS THE INPUT VALUES DABS(F(B)), */
/*              DABS(F(C)).  IN THIS CASE IT IS LIKELY THAT B IS CLOSE */
/*              TO A POLE OF F. */

/*          =4  IF NO ODD ORDER ROOT WAS FOUND IN THE INTERVAL.  A */
/*              LOCAL MINIMUM MAY HAVE BEEN OBTAINED. */

/*          =5  IF TOO MANY FUNCTION EVALUATIONS WERE MADE. */
/*              (AS PROGRAMMED, 500 ARE ALLOWED.) */

/*  THIS CODE IS A MODIFICATION OF THE CODE ZEROIN WHICH IS COMPLETELY */
/*  EXPLAINED AND DOCUMENTED IN THE TEXT  NUMERICAL COMPUTING:  AN */
/*  INTRODUCTION,  BY L. F. SHAMPINE AND R. C. ALLEN. */

/*  CALLS  D1MACH . */


    if (*iflag >= 0) {
	goto L100;
    }
    *iflag = abs(*iflag);
    switch (*iflag) {
	case 1:  goto L200;
	case 2:  goto L300;
	case 3:  goto L400;
    }
L100:
    RootVars->u = d1mach_(&RootVars->c__4);
    RootVars->re = max(*relerr,RootVars->u);
    RootVars->ae = max(*abserr,0.);
    RootVars->ic = 0;
    RootVars->acbs = (d__1 = *b - *c__, abs(d__1));
    RootVars->a = *c__;
    *t = RootVars->a;
    *iflag = -1;
    return 0;
L200:
    RootVars->fa = *ft;
    *t = *b;
    *iflag = -2;
    return 0;
L300:
    RootVars->fb = *ft;
    RootVars->fc = RootVars->fa;
    RootVars->kount = 2;
/* Computing MAX */
    d__1 = abs(RootVars->fb), d__2 = abs(RootVars->fc);
    RootVars->fx = max(d__1,d__2);
L1:
    if (abs(RootVars->fc) >= abs(RootVars->fb)) {
	goto L2;
    }

/*  INTERCHANGE B AND C SO THAT ABS(F(B)).LE.ABS(F(C)). */

    RootVars->a = *b;
    RootVars->fa = RootVars->fb;
    *b = *c__;
    RootVars->fb = RootVars->fc;
    *c__ = RootVars->a;
    RootVars->fc = RootVars->fa;
L2:
    RootVars->cmb = (*c__ - *b) * .5f;
    RootVars->acmb = abs(RootVars->cmb);
    RootVars->tol = RootVars->re * abs(*b) + RootVars->ae;

/*  TEST STOPPING CRITERION AND FUNCTION COUNT. */

    if (RootVars->acmb <= RootVars->tol) {
	goto L8;
    }
    if (RootVars->kount >= 500) {
	goto L12;
    }

/*  CALCULATE NEW ITERATE EXPLICITLY AS B+P/Q */
/*  WHERE WE ARRANGE P.GE.0.  THE IMPLICIT */
/*  FORM IS USED TO PREVENT OVERFLOW. */

    RootVars->p = (*b - RootVars->a) * RootVars->fb;
    RootVars->q = RootVars->fa - RootVars->fb;
    if (RootVars->p >= 0.f) {
	goto L3;
    }
    RootVars->p = -RootVars->p;
    RootVars->q = -RootVars->q;

/*  UPDATE A, CHECK IF REDUCTION IN THE SIZE OF BRACKETING */
/*  INTERVAL IS SATISFACTORY.  IF NOT BISECT UNTIL IT IS. */

L3:
    RootVars->a = *b;
    RootVars->fa = RootVars->fb;
    ++RootVars->ic;
    if (RootVars->ic < 4) {
	goto L4;
    }
    if (RootVars->acmb * 8.f >= RootVars->acbs) {
	goto L6;
    }
    RootVars->ic = 0;
    RootVars->acbs = RootVars->acmb;

/*  TEST FOR TOO SMALL A CHANGE. */

L4:
    if (RootVars->p > abs(RootVars->q) * RootVars->tol) {
	goto L5;
    }

/*  INCREMENT BY TOLERANCE */

    *b += d_sign(&RootVars->tol, &RootVars->cmb);
    goto L7;

/*  ROOT OUGHT TO BE BETWEEN B AND (C+B)/2 */

L5:
    if (RootVars->p >= RootVars->cmb * RootVars->q) {
	goto L6;
    }

/*  USE SECANT RULE. */

    *b += RootVars->p / RootVars->q;
    goto L7;

/*  USE BISECTION. */

L6:
    *b = (*c__ + *b) * .5f;

/*  HAVE COMPLETED COMPUTATION FOR NEW ITERATE B. */

L7:
    *t = *b;
    *iflag = -3;
    return 0;
L400:
    RootVars->fb = *ft;
    if (RootVars->fb == 0.f) {
	goto L9;
    }
    ++RootVars->kount;
    if (d_sign(&RootVars->c_b17, &RootVars->fb) != d_sign(&RootVars->c_b17, &RootVars->fc)) {
	goto L1;
    }
    *c__ = RootVars->a;
    RootVars->fc = RootVars->fa;
    goto L1;

/* FINISHED.  SET IFLAG. */

L8:
    if (d_sign(&RootVars->c_b17, &RootVars->fb) == d_sign(&RootVars->c_b17, &RootVars->fc)) {
	goto L11;
    }
    if (abs(RootVars->fb) > RootVars->fx) {
	goto L10;
    }
    *iflag = 1;
    return 0;
L9:
    *iflag = 2;
    return 0;
L10:
    *iflag = 3;
    return 0;
L11:
    *iflag = 4;
    return 0;
L12:
    *iflag = 5;
    return 0;
} /* root_ */

