#include "stdafx.h"
#include "EditDisable.h"

BEGIN_MESSAGE_MAP(CEditDisable, CEdit)
	ON_MESSAGE(WM_PASTE, OnPaste)
	ON_MESSAGE(WM_CUT, OnCut)
	ON_MESSAGE(WM_UNDO, OnUndo)
	ON_MESSAGE(WM_CLEAR, OnDelete)
END_MESSAGE_MAP()

CEditDisable::CEditDisable() : CEdit() {
	disable = FALSE;
	Ctrl_down = FALSE;
}

BOOL CEditDisable::PreTranslateMessage(MSG* pMsg)
{
	if (!disable) {
		Ctrl_down = FALSE;
		return CEdit::PreTranslateMessage(pMsg);
	}
	if (pMsg->message == WM_KEYDOWN) {
		if (pMsg->wParam == VK_CONTROL) {
			Ctrl_down = TRUE;
			return CEdit::PreTranslateMessage(pMsg);
		}
		else if (pMsg->wParam == VK_DELETE) {
			return TRUE;
		}
	}
	else if (pMsg->message == WM_KEYUP) {
		if (pMsg->wParam == VK_CONTROL) {
			Ctrl_down = FALSE;
			return CEdit::PreTranslateMessage(pMsg);
		}
		else if (pMsg->wParam == VK_DELETE) {
			return TRUE;
		}
	}
	if (Ctrl_down || pMsg->message != WM_CHAR) return CEdit::PreTranslateMessage(pMsg);
	return TRUE;
}

LRESULT CEditDisable::OnPaste(WPARAM wParam, LPARAM lParam)
{
	if (!disable) return Default();
	else return 0;
}

LRESULT CEditDisable::OnCut(WPARAM wParam, LPARAM lParam)
{
	if (!disable) return Default();
	else return 0;
}

LRESULT CEditDisable::OnUndo(WPARAM wParam, LPARAM lParam)
{
	if (!disable) return Default();
	else return 0;
}

LRESULT CEditDisable::OnDelete(WPARAM wParam, LPARAM lParam)
{
	if (!disable) return Default();
	else return 0;
}
