
// MCNScript.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "MCNScriptDlg.h"
#include "MCNScript.h"
#include <psapi.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#include "HyperLink.h"

// CMCNScriptApp

BEGIN_MESSAGE_MAP(CMCNScriptApp, CWinApp)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_COMMAND(ID_HELP, OnHelpUserManual)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
END_MESSAGE_MAP()


// CMCNScriptApp construction

CMCNScriptApp::CMCNScriptApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CMCNScriptApp object

CMCNScriptApp theApp;


// CMCNScriptApp initialization

BOOL CMCNScriptApp::InitInstance()
{
	CWinApp::InitInstance();


	// Create the shell manager, in case the dialog contains
	// any shell tree view or shell list view controls.
	CShellManager *pShellManager = new CShellManager;

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	SetRegistryKey(_T("MCNScript"));

	LoadStdProfileSettings(10);  // Load standard INI file options (including MRU)

	// Enable DDE Execute open
	EnableShellOpen();
//	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	ProcessShellCommand(cmdInfo);

	CMCNScriptDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Delete the shell manager created above.
	if (pShellManager != NULL)
	{
		delete pShellManager;
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

int CMCNScriptApp::ExitInstance()
{
	HWND consoleWndHandle = GetConsoleWindow();
	if (consoleWndHandle && IsWindow(consoleWndHandle)) {
		FreeConsole();
		ShowWindow(consoleWndHandle, SW_HIDE);
		PostMessage(consoleWndHandle, WM_CLOSE, 0, 0);
	}
	return CWinApp::ExitInstance();
}

CDocument* CMCNScriptApp::OpenDocumentFile(LPCTSTR lpszFileName)
{
	CString pathName = lpszFileName;
	strcpy(parFileName, pathName.GetBuffer()); pathName.ReleaseBuffer();
	return NULL;
}

void CMCNScriptApp::OnFileOpen()
{
	CMCNScriptDlg *dialog = (CMCNScriptDlg *)pDlg;
	dialog->m_MGEDcmdLineCapt.SetFocus();
	if (dialog->changed) {
		int rc = dialog->MessageBox("Do you want to save the changes?", NULL, MB_YESNOCANCEL | MB_ICONQUESTION);
		if (rc == IDCANCEL) return;
		if (rc == IDYES && !dialog->OnSave()) return;
	}

	char drive[1000], dir[1000], fname[1000], ext[1000];
	char fileName[1000], path[1000];
	bool nameIsEmpty = (strspn(parFileName, " \t") == strlen(parFileName));
	if (!nameIsEmpty) {
		_splitpath(parFileName, drive, dir, fname, ext);
		sprintf(path, "%s%s", drive, dir);
		sprintf(fileName, "%s%s", fname, ext);
	}
	else fileName[0] = '\0';
//	CFileDialog dlg(TRUE, "*.mcnprm", NULL, OFN_EXPLORER|OFN_ENABLESIZING, "MCNScript files (*.mcnprm)|*.mcnprm|All files (*.*)|*.*||", NULL);
	CFileDialog dlg(TRUE, "*.mcnprm", fileName, OFN_EXPLORER|OFN_ENABLESIZING, "MCNScript files (*.mcnprm)|*.mcnprm|All files (*.*)|*.*||", NULL);
	if (!nameIsEmpty) dlg.m_ofn.lpstrInitialDir = path;
	else dlg.m_ofn.lpstrInitialDir = NULL;
	dlg.m_ofn.lpstrTitle = "Open a parameter file";
	if (dlg.DoModal() == IDOK) {
		strcpy(parFileName, dlg.GetPathName());
		dialog->FreeAll();
		dialog->OnOpen();
	}
}

void CMCNScriptApp::OnFileSave()
{
	((CMCNScriptDlg *)pDlg)->OnSave();
}

void CMCNScriptApp::OnFileSaveAs()
{
	((CMCNScriptDlg *)pDlg)->OnSaveAs();
}

void CMCNScriptApp::OnHelpUserManual()
{
	CString docName = (CString)((CMCNScriptDlg *)pDlg)->exePath + "Docs\\MCNScript - User Manual.pdf";
	int rc = (int)ShellExecute(NULL, "open", docName, NULL, NULL, SW_SHOWNORMAL);
	if (rc <= 32) pDlg->MessageBox((CString)"File \"" + docName + "\" could not be opened.", NULL, MB_OK | MB_ICONERROR);
}

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg() : CDialogEx(CAboutDlg::IDD) {}; // standard constructor
	void DoDataExchange(CDataExchange* pDX);
	enum { IDD = IDD_ABOUT };
	CHyperLink	m_hyperLink, m_hyperLink_ENDF1, m_hyperLink_ENDF2, m_hyperLink_ENDF3, m_hyperLink_BRLCAD;
};

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_HYPERLINK, m_hyperLink);
	DDX_Control(pDX, IDC_HYPERLINK_ENDF1, m_hyperLink_ENDF1);
	DDX_Control(pDX, IDC_HYPERLINK_ENDF2, m_hyperLink_ENDF2);
	DDX_Control(pDX, IDC_HYPERLINK_ENDF3, m_hyperLink_ENDF3);
	DDX_Control(pDX, IDC_HYPERLINK_BRLCAD, m_hyperLink_BRLCAD);
}

void CMCNScriptApp::OnAppAbout()
{
	CAboutDlg dlg;
	dlg.DoModal();
}

CRecentFileList* CMCNScriptApp::GetRecentFileList()
{
	return m_pRecentFileList;
}
