#include "stdafx.h"
#include "MCNScriptDlg.h"
#include "MCNScript.h"
#include "SystemVarsDlg.h"

IMPLEMENT_DYNAMIC(CSystemVarsDlg, CDialog)

CSystemVarsDlg::CSystemVarsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSystemVarsDlg::IDD, pParent)
{
	parent = pParent;
	systemVars = ((CMCNScriptDlg *)parent)->systemVars;
}

CSystemVarsDlg::~CSystemVarsDlg()
{
}

void CSystemVarsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SYSTEMVARS, m_systemVarsGrid);
}

BEGIN_MESSAGE_MAP(CSystemVarsGridCtrl, CGridCtrl)
	ON_WM_KILLFOCUS()
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CSystemVarsDlg, CDialog)
	ON_NOTIFY(GVN_ENDLABELEDIT, IDC_SYSTEMVARS, OnSystemVarsGridEndEdit)
END_MESSAGE_MAP()

BOOL CSystemVarsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	UpdateData();
	CRect rect;
	m_systemVarsGrid.GetClientRect(&rect);
	sysVarsRowHeight = GetSystemMetrics(SM_CYVSCROLL) + 2;
	int sysVarsRowsVisible = rect.bottom / sysVarsRowHeight - 1;
	if (sysVarsRowsVisible > 10) sysVarsRowsVisible = 10;
	sysVarsHeaderHeight = rect.bottom - sysVarsRowsVisible * sysVarsRowHeight;
	int additionalHeight = (sysVarsHeaderHeight - sysVarsRowHeight) / sysVarsRowsVisible;
	sysVarsRowHeight += additionalHeight;
	sysVarsHeaderHeight -= sysVarsRowsVisible * additionalHeight;
	m_systemVarsGrid.SetColumnResize(TRUE);
	m_systemVarsGrid.nAutoCols = 1;
	m_systemVarsGrid.autoCol.SetSize(m_systemVarsGrid.nAutoCols);
	m_systemVarsGrid.autoCol[0] = 1;
	m_systemVarsGrid.SetFont(GetFont());
	m_systemVarsGrid.m_disableCut = TRUE;
	m_systemVarsGrid.SetRowCount(1);
	m_systemVarsGrid.SetColumnCount(2);
	m_systemVarsGrid.isColReadOnly.SetSize(2);
	m_systemVarsGrid.isColReadOnly[0] = TRUE;
	m_systemVarsGrid.isColReadOnly[1] = FALSE;
	m_systemVarsGrid.SetFixedRowCount(1);
	m_systemVarsGrid.SetFixedColumnCount(0);
	m_systemVarsGrid.SetRowHeight(0, sysVarsHeaderHeight);
	m_systemVarsGrid.SetItemText(0, 0, "Name");
	m_systemVarsGrid.SetItemText(0, 1, "Value");
	char tmp[1000];
    m_systemVarsGrid.SetSelectedRange(-1,-1,-1,-1);
	m_systemVarsGrid.SetFocusCell(-1,-1);
	m_systemVarsGrid.SetRowCount(11);
	int i;
	for (i = 1; i < 11; i++) {
		m_systemVarsGrid.SetRowHeight(i, sysVarsRowHeight);
		sprintf(tmp, "@%d ", i - 1);
		m_systemVarsGrid.SetItemText(i, 0, tmp);
	}
	m_systemVarsGrid.ResetWidth();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSystemVarsDlg::OnSystemVarsGridEndEdit(NMHDR *pNotifyStruct, LRESULT *pResult)
{
	NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;
	CMCNScriptDlg *p = (CMCNScriptDlg *)parent;
    CGridCellBase* pCell = m_systemVarsGrid.GetCell(pItem->iRow, pItem->iColumn);
	CEdit *pEdit = (CEdit *)pCell->GetEditWnd();
	CString text = m_systemVarsGrid.GetItemText(pItem->iRow, pItem->iColumn);
	char tmp[101];
	strncpy(tmp, text.GetBuffer(), 100);
	tmp[100] = '\0';
	int i = pItem->iRow - 1;
	char outputString[101];
	outputString[0] = '\0';
	char *endPtr;
	double value = strtod(tmp, &endPtr);
	if ((*endPtr == '\0' || *endPtr == ' ' || *endPtr == '\t') && value >= -DBL_MAX && value <= DBL_MAX) sprintf(outputString, "%.16g", value);
	if (outputString[0] == '\0' || value == systemVars[i]) {
		*pResult = -1;
		return;
	}
	systemVars[i] = value;
	p->changed = true;
	p->MakeCmdLine();
	m_systemVarsGrid.SetItemText(pItem->iRow, pItem->iColumn, outputString);
	m_systemVarsGrid.ResetWidth();
	*pResult = 0;
}

void CSystemVarsGridCtrl::OnKillFocus(CWnd *pNewWnd)
{
	CCellID cellID = GetFocusCell();
	CGridCtrl::OnKillFocus(pNewWnd);
    SetSelectedRange(-1,-1,-1,-1);
	SetFocusCell(-1,-1);
}
