#include "stdafx.h"
#include "MCNScriptDlg.h"
#include "TabFilteringByParticleType.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabFilteringByParticleType dialog

CTabFilteringByParticleType::CTabFilteringByParticleType(CWnd* pParent /*=NULL*/)
	: CDialog(CTabFilteringByParticleType::IDD, pParent)
{
}

void CTabFilteringByParticleType::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BOOL CTabFilteringByParticleType::OnInitDialog()
{
	CDialog::OnInitDialog();

	VERIFY(m_originType[0].SubclassDlgItem(IDC_SOURCE, this));
	VERIFY(m_originType[1].SubclassDlgItem(IDC_BREMS, this));
	VERIFY(m_originType[2].SubclassDlgItem(IDC_ANNIH, this));
	VERIFY(m_originType[3].SubclassDlgItem(IDC_XRAY_EL, this));
	VERIFY(m_originType[4].SubclassDlgItem(IDC_XRAY_PHOT, this));
	VERIFY(m_originType[5].SubclassDlgItem(IDC_PP_EL, this));
	VERIFY(m_originType[6].SubclassDlgItem(IDC_PP_POS, this));
	VERIFY(m_originType[7].SubclassDlgItem(IDC_COMPTON_RECOIL, this));
	VERIFY(m_originType[8].SubclassDlgItem(IDC_PHOTOEL, this));
	VERIFY(m_originType[9].SubclassDlgItem(IDC_AUGER_PHOT, this));
	VERIFY(m_originType[10].SubclassDlgItem(IDC_AUGER_EL, this));
	VERIFY(m_originType[11].SubclassDlgItem(IDC_KNOCK_ON, this));
	VERIFY(m_genMin.SubclassDlgItem(IDC_GENMIN, this));
	VERIFY(m_genMax.SubclassDlgItem(IDC_GENMAX, this));

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BEGIN_MESSAGE_MAP(CTabFilteringByParticleType, CDialog)
	ON_BN_CLICKED(IDC_SOURCE, OnOriginType0)
	ON_BN_CLICKED(IDC_BREMS, OnOriginType1)
	ON_BN_CLICKED(IDC_ANNIH, OnOriginType2)
	ON_BN_CLICKED(IDC_XRAY_EL, OnOriginType3)
	ON_BN_CLICKED(IDC_XRAY_PHOT, OnOriginType4)
	ON_BN_CLICKED(IDC_PP_EL, OnOriginType5)
	ON_BN_CLICKED(IDC_PP_POS, OnOriginType6)
	ON_BN_CLICKED(IDC_COMPTON_RECOIL, OnOriginType7)
	ON_BN_CLICKED(IDC_PHOTOEL, OnOriginType8)
	ON_BN_CLICKED(IDC_AUGER_PHOT, OnOriginType9)
	ON_BN_CLICKED(IDC_AUGER_EL, OnOriginType10)
	ON_BN_CLICKED(IDC_KNOCK_ON, OnOriginType11)
	ON_EN_KILLFOCUS(IDC_GENMIN, OnGenMinEdit)
	ON_EN_KILLFOCUS(IDC_GENMAX, OnGenMaxEdit)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabFilteringByParticleType message handlers

void CTabFilteringByParticleType::OriginType(int i)
{
	CMCNScriptDlg *p = (CMCNScriptDlg *)parent;
	pTrackFilter->originTypeMask ^= p->bitMask[i];
	if (parent == parent2) {
		CMCNScriptDlg *p = (CMCNScriptDlg *)parent;
		p->changed = true;
		p->m_nTracks.SetWindowText("");
	}
	else {
		CTrackStatsDlg *p2 = (CTrackStatsDlg *)parent2;
		p2->Clear_nTracks();
	}
	CGridCellCheck *pCheck = (CGridCellCheck *)p->pTrackColorsGrid->GetCell(i + 1, 2);
	pCheck->m_bChecked = ((p->bitMask[i] & pTrackFilter->originTypeMask) != 0);
	p->UpdateShow_tracks(pCheck->m_bChecked, i);
	p->pTrackColorsGrid->Invalidate();
	p->pTrackColorsGrid->UpdateWindow();
}

void CTabFilteringByParticleType::OnOriginType0() { OriginType(0); }
void CTabFilteringByParticleType::OnOriginType1() { OriginType(1); }
void CTabFilteringByParticleType::OnOriginType2() { OriginType(2); }
void CTabFilteringByParticleType::OnOriginType3() { OriginType(3); }
void CTabFilteringByParticleType::OnOriginType4() { OriginType(4); }
void CTabFilteringByParticleType::OnOriginType5() { OriginType(5); }
void CTabFilteringByParticleType::OnOriginType6() { OriginType(6); }
void CTabFilteringByParticleType::OnOriginType7() { OriginType(7); }
void CTabFilteringByParticleType::OnOriginType8() { OriginType(8); }
void CTabFilteringByParticleType::OnOriginType9() { OriginType(9); }
void CTabFilteringByParticleType::OnOriginType10() { OriginType(10); }
void CTabFilteringByParticleType::OnOriginType11() { OriginType(11); }

void CTabFilteringByParticleType::OnGenMinEdit()
{
	char tmp[100], outputString[100];
	int nBytes = m_genMin.GetLine(0, tmp, 99);
	tmp[nBytes] = '\0';
	CMCNScriptDlg *p = (CMCNScriptDlg *)parent;
	int num = p->CheckInteger(tmp, outputString, 1, 2147483647);
	if (outputString[0] != '\0' && num != pTrackFilter->gen[0]) {
		pTrackFilter->gen[0] = num;
		if (parent2 == parent) {
			p->changed = true;
			p->m_nTracks.SetWindowText("");
		}
		else {
			CTrackStatsDlg *p2 = (CTrackStatsDlg *)parent2;
			p2->Clear_nTracks();
		}
	}
	sprintf(tmp, "%d", pTrackFilter->gen[0]);
	m_genMin.SetWindowText(tmp);
	p->pTrackColorsDlg->m_genMin.SetWindowText(tmp);
}

void CTabFilteringByParticleType::OnGenMaxEdit()
{
	char tmp[100], outputString[100];
	int nBytes = m_genMax.GetLine(0, tmp, 99);
	tmp[nBytes] = '\0';
	int num;
	bool empty = (strspn(tmp, " \t") == strlen(tmp));
	CMCNScriptDlg *p = (CMCNScriptDlg *)parent;
	if (empty) num = -1;
	else num = p->CheckInteger(tmp, outputString, -1, 2147483647);
	if ((empty || outputString[0] != '\0') && num != pTrackFilter->gen[1]) {
		pTrackFilter->gen[1] = num;
		if (parent2 == parent) {
			p->changed = true;
			p->m_nTracks.SetWindowText("");
		}
		else {
			CTrackStatsDlg *p2 = (CTrackStatsDlg *)parent2;
			p2->Clear_nTracks();
		}
	}
	if (pTrackFilter->gen[1] >= 0) {
		sprintf(tmp, "%d", pTrackFilter->gen[1]);
		m_genMax.SetWindowText(tmp);
		p->pTrackColorsDlg->m_genMax.SetWindowText(tmp);
	}
	else {
		m_genMax.SetWindowText("");
		p->pTrackColorsDlg->m_genMax.SetWindowText("");
	}
}
