#include "stdafx.h"
#include "MCNScriptDlg.h"
#include "TabFilteringByTransportParameters.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTabFilteringByTransportParameters dialog

CTabFilteringByTransportParameters::CTabFilteringByTransportParameters(CWnd* pParent /*=NULL*/)
	: CDialog(CTabFilteringByTransportParameters::IDD, pParent)
{
}

void CTabFilteringByTransportParameters::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_TRACKFILTER, m_trackFilterGrid);
}

BOOL CTabFilteringByTransportParameters::OnInitDialog()
{
	CDialog::OnInitDialog();

	CGridCtrl *pGrid = &m_trackFilterGrid;
	CRect rect;
	pGrid->GetClientRect(&rect);
	pGrid->SetRowCount(11);
	pGrid->SetColumnCount(3);
	pGrid->isColReadOnly.SetSize(3);
	pGrid->isColReadOnly[0] = TRUE;
	pGrid->isColReadOnly[1] = FALSE;
	pGrid->isColReadOnly[2] = FALSE;
	pGrid->SetFixedRowCount(1);
	pGrid->SetFixedColumnCount(0);
	pGrid->SetColumnResize(TRUE);
	pGrid->nAutoCols = 1;
	pGrid->autoCol.SetSize(pGrid->nAutoCols);
	pGrid->autoCol[0] = 0;
	int rowHeight = rect.bottom / 11;
	int nAddHeight = rect.bottom - 11 * rowHeight;
	int j, k;
	for (j = 0; j < 11; j++) {
		if (j < nAddHeight) pGrid->SetRowHeight(j, rowHeight + 1);
		else pGrid->SetRowHeight(j, rowHeight);
		pGrid->SetItemState(j, 0, pGrid->GetItemState(j, 0) | GVIS_READONLY);
	    for (k = 0; k < 3; k++) if (!j || k) pGrid->SetItemFormat(j, k, DT_CENTER|DT_VCENTER|DT_SINGLELINE|DT_END_ELLIPSIS|DT_NOPREFIX);
	}
	pGrid->SetFont(GetFont());

	return TRUE;  // return TRUE  unless you set the focus to a control
}

BOOL CTabFilteringByTransportParameters::PreTranslateMessage(MSG *pMsg) 
{
	if (pMsg->message >= WM_KEYFIRST && pMsg->message <= WM_KEYLAST && m_hAccel != NULL) {
			if (::TranslateAccelerator(m_hWnd, m_hAccel, pMsg)) return TRUE;
	}
	return CDialog::PreTranslateMessage(pMsg);
}

BEGIN_MESSAGE_MAP(CTabFilteringByTransportParameters, CDialog)
	ON_NOTIFY(GVN_ENDLABELEDIT, IDC_TRACKFILTER, OnTrackFilterGridEndEdit)
	ON_COMMAND(ID_AUTOSIZEGRID, OnAutosizeGrid)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTabFilteringByTransportParameters message handlers

void CTabFilteringByTransportParameters::OnTrackFilterGridEndEdit(NMHDR *pNotifyStruct, LRESULT *pResult)
{
	NM_GRIDVIEW* pItem = (NM_GRIDVIEW*) pNotifyStruct;
    CGridCellBase* pCell = m_trackFilterGrid.GetCell(pItem->iRow, pItem->iColumn);
	CEdit *pEdit = (CEdit *)pCell->GetEditWnd();
	CString text = m_trackFilterGrid.GetItemText(pItem->iRow, pItem->iColumn);
	char tmp[1000];
	strcpy(tmp, text.GetBuffer());
	CMCNScriptDlg *p = (CMCNScriptDlg *)parent;
	if (p->TrackFilterGridEndEdit(pTrackFilter, &m_trackFilterGrid, pItem->iRow, pItem->iColumn, tmp, pResult)) {
		if (parent == parent2) {
			p->changed = true;
			p->m_nTracks.SetWindowText("");
		}
		else {
			CTrackStatsDlg *p2 = (CTrackStatsDlg *)parent2;
			p2->Clear_nTracks();
		}
	}
}

void CTabFilteringByTransportParameters::OnAutosizeGrid()
{
	m_trackFilterGrid.ResetWidth();
}
